/*

  MINIGUI - Harbour Win32 GUI library Demo/Sample

  Copyright 2002-08 Roberto Lopez <harbourminigui@gmail.com>
  http://harbourminigui.googlepages.com

  'CuckooClock' is Open Source/Freevare HMG Demo / Sample,
  dedicated exclusively to HMGForum members.

  All bug reports and suggestions are welcome.

  Developed with MiniGUI  - Harbour Win32 GUI library (HMG),
  Compiled and Linked with Harbour Compiler and MinGW.

  Thanks to "Le Roy" Roberto Lopez.

  Copyright 2009  Bicahi Esgici <esgici @ gmail.com>

  History : 2009-6 : First Release
                                                           
                                  
  Notes : 
  
   - 'CuckooClock' uses "LcdD" font and this font is in LCDN.TTF font file. 
     This font file exists standard distribution of Windows XP but as far as I know
     not found in Vista. If so you can use it simply by copying this font file to your 
     Windows\fonts folder. You can use anything else of course. 
      
   - This sample is a standalone application. If you want use it into your own application :
     add CuckooClock() calling line to your main window's ON INIT event and change "MAIN" 
     property of frmCuckooClock to "CHILD"
   

   - For seeing CDOW() ( Name of day of week ) in your own language 
     add following two lines at top of Main() procedure / function :
     
     REQUEST HB_LANG_xx
     HB_LANGSELECT( "xx" ) 
     
     and replace "xx" in it with your language code.

           
*/

#include "minigui.ch"

PROC Main()
   
   REQUEST HB_LANG_ES
   HB_LANGSELECT( "ES" ) 

   SET CENT ON
   SET DATE GERM
   
   CuckooClock()
   
RETU // Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

STATIC PROC CuckooClock( nCaller )

   STATIC lIsColon := .T. ,;
          lSound   := .T. ,;
          lSeconds := .T. ,;
          aLMetrcs := { { 40, 10, 40, 10, 40 }, { 25, 40, 10, 40, 25 } }

   LOCAL cFrmName    := '' ,;
         aCCPrpArray := ARRAY( 5 ),;
         cCurTime    := TIME(),;
         aTmpColor   := {},;
         nLblType    :=  0,;
         nlblRow     :=  5,;
         nlblWidth   :=  0,;
         cDigit      := ''

   IF HB_ISNIL( nCaller )
   
      DEFINE WINDOW frmCuckooClock ;
         AT GetDesktopHeight() - 110, GetDesktopWidth() - 150 ; 
         WIDTH  150 ; 
         HEIGHT  75 ;
         MAIN ; // CHILD ; 
         ICON 'cucko.Ico'; 
         NOCAPTION ;
         NOSIZE ;
         NOMAXIMIZE ;
         BACKCOLOR BLUE ;
         TOPMOST ;
         ON INIT CuckooClock( 0 )
      
         ON KEY ESCAPE ACTION frmCuckooClock.Release      
      
         nlblRow   := 5
         nlblWidth := 0
         
         FOR nDigit := 1 TO 5
            cDigit := "lblClock" + LTRIM( STR( nDigit ) ) 
            nlblWidth := aLMetrcs[ 1, nDigit ] 
            IF nDigit < 5
               @ 5, nlblRow LABEL &cDigit HEIGHT 40 WIDTH nlblWidth FONT "LcdD" SIZE 25 CENTERALIGN  BACKCOLOR { 0, 0, 160 } FONTCOLOR WHITE  // aColors[ nDigit ]
            ELSE
               @ 5, nlblRow LABEL &cDigit HEIGHT 40 WIDTH nlblWidth FONT "LcdD" SIZE 25 BACKCOLOR { 0, 0, 160 } FONTCOLOR WHITE // 
            ENDIF
            nlblRow += nlblWidth
         NEXT    
         
         DEFINE TIMER  tmrClock INTERVAL 1000 ACTION CuckooClock( 0 ) // OF &cFrmName 
                    
         @ 45, 5 LABEL lblDate  HEIGHT 24 WIDTH 140 VALUE DATE() FONT "Tahoma" SIZE 10 CENTERALIGN BACKCOLOR { 0, 0, 160 } FONTCOLOR YELLOW 
         
         DEFINE CONTEXT MENU // OF &cFrmName 
            MENUITEM "Backcolor"                     ACTION CuckooClock( 1 )
            MENUITEM "Watch color"                   ACTION CuckooClock( 2 )
            MENUITEM "Date color"                    ACTION CuckooClock( 3 )
            MENUITEM "Sound"   NAME cmuSound CHECKED ACTION CuckooClock( 4 )
            MENUITEM "Seconds" NAME cmuSecos CHECKED ACTION CuckooClock( 5 )
            MENUITEM "Hide"                          ACTION frmCuckooClock.Minimize
            SEPARATOR
            MENUITEM "Close   ( Esc)"                ACTION frmCuckooClock.Release
         END MENU
      
      END WINDOW // frmCuckooClock
      
      frmCuckooClock.Activate
      
   ELSE
   
      cFrmName := ThisWindow.Name
      
      IF nCaller > 0  
      
         IF nCaller > 4     // 5: Seconds
         
            lSeconds := !lSeconds
            frmCuckooClock.cmuSecos.Checked := lSeconds
            
            nLblType  := IF( lSeconds, 1, 2 )
            
            FOR nDigit := 1 TO 5
               cDigit := "lblClock" + LTRIM( STR( nDigit ) ) 
               nlblWidth := aLMetrcs[ nLblType, nDigit ] // IF( INT( nDigit / 2 ) # nDigit / 2, 40, 10 )
               SetProperty( cFrmName, cDigit, "COL",   nlblRow  )
               SetProperty( cFrmName, cDigit, "WIDTH", nlblWidth  )
               SetProperty( cFrmName, cDigit, "VALUE", '' )
               nlblRow += nlblWidth
            NEXT    
         
            lIsColon := lSeconds
            
         ELSEIF nCaller > 3     // 4: Sound 
            lSound := !lSound
            frmCuckooClock.cmuSound.Checked := lSound
         ELSE                   // 1..3 : Colors
            aTmpColor := GetColor()
            
            IF !HB_ISNIL( aTmpColor[ 1 ] )
               IF nCaller == 1 // Back Color
                  AFILL( aCCPrpArray, aTmpColor )
                  CCSetProp( cFrmName, "BackColor", aCCPrpArray )
                  frmCuckooClock.lblDate.BackColor   := aTmpColor
               ELSEIF nCaller == 2 // Oclok ForeColor
                  AFILL( aCCPrpArray, aTmpColor )
                  CCSetProp( cFrmName, "FontColor", aCCPrpArray )
               ELSEIF nCaller == 3 // Date ForeColor
                  frmCuckooClock.lblDate.FontColor := aTmpColor
               ENDIF
            ENDIF !HB_ISNIL( aTmpColor[ 1 ] )
         ENDIF
      
      ENDIF nCaller > 0  // Colors
   ENDIF HB_ISNIL( nCaller )

*----------------- New Change  -------------------------*
  IF lSound

        hora = TIME()
        minut = SUBSTR( hora , 4 , 2 ) 

      IF RIGHT( cCurTime, 2 ) == "00"      
        IF minut == "15"
           PLAY WAVE "RESWAVC1" FROM RESOURCE    
        ENDIF
        IF minut == "30"
           PLAY WAVE "RESWAVC2" FROM RESOURCE    
        ENDIF   
        IF minut == "45"
           PLAY WAVE "RESWAVC3" FROM RESOURCE             
        ENDIF      
        IF minut == "00"
           PLAY WAVE "RESWAVC4" FROM RESOURCE    
        ENDIF     

     ENDIF

 ENDIF lSound
*--------------------------------------------------------*


*   IF lSound
*      IF RIGHT( cCurTime, 2 ) == "00"
*         IF SUBS( cCurTime, 4, 2 ) == "00"
*            PLAY WAVE "RESWAVC2" FROM RESOURCE
*         ELSEIF SUBS( cCurTime, 4, 2 ) == "30"
*            PLAY WAVE "RESWAVC1" FROM RESOURCE
*         ENDIF
*      ENDIF
*   ENDIF lSound


   IF lSeconds
      aCCPrpArray := { SUBS( cCurTime, 1, 2 ), ":", SUBS( cCurTime, 4, 2 ), ":", SUBS( cCurTime, 7, 2 ) }
   ELSE
      lIsColon := !lIsColon
      aCCPrpArray := { '', SUBS( cCurTime, 1, 2 ), IF( lIsColon, ":", '' ), SUBS( cCurTime, 4, 2 ), '' }
   ENDIF lSeconds
   
   CCSetProp( cFrmName, "Value", aCCPrpArray )
       
   frmCuckooClock.lblDate.Value  := DTOC( DATE() ) + "-" + CDOW( DATE() )


RETU // CuckooClock()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

STATIC PROC CCSetProp( cFrmName, cProperty, aValues )

   LOCAL nDigit := 0,;
         cDigit := ''
         
   FOR nDigit := 1 TO 5
      cDigit := "lblClock" + LTRIM( STR( nDigit ) ) 
      SetProperty( cFrmName, cDigit, cProperty, aValues[ nDigit ] )      
   NEXT    

RETU // CCSetProp()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.




